
# Card

### Description

Represents the payment details of a card to be used for payments. These details are determined by the `card_nonce` generated by `SqPaymentForm`.

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **String** | Unique ID for this card. Generated by Square. |  [optional]
**cardBrand** | **String** | The card&#39;s brand (such as &#x60;VISA&#x60;). See [CardBrand](#type-cardbrand) for possible values |  [optional]
**last4** | **String** | The last 4 digits of the card number. |  [optional]
**expMonth** | **Long** | The expiration month of the associated card as an integer between 1 and 12. |  [optional]
**expYear** | **Long** | The four-digit year of the card&#39;s expiration date. |  [optional]
**cardholderName** | **String** | The name of the cardholder. |  [optional]
**billingAddress** | [**Address**](Address.md) | The billing address for this card. |  [optional]
**fingerprint** | **String** | A unique, Square-assigned ID that identifies the card across multiple locations and applications for a single Square account. |  [optional]



