/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.BreakType;
import com.squareup.connect.models.Error;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * The response to the request to create a &#x60;BreakType&#x60;. Contains the created &#x60;BreakType&#x60; object. May contain a set of &#x60;Error&#x60; objects if the request resulted in errors.
 */
@ApiModel(description = "The response to the request to create a `BreakType`. Contains the created `BreakType` object. May contain a set of `Error` objects if the request resulted in errors.")

public class CreateBreakTypeResponse {
  @JsonProperty("break_type")
  private BreakType breakType = null;

  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  public CreateBreakTypeResponse breakType(BreakType breakType) {
    this.breakType = breakType;
    return this;
  }

   /**
   * The `BreakType` that was created by the request.
   * @return breakType
  **/
  @ApiModelProperty(value = "The `BreakType` that was created by the request.")
  public BreakType getBreakType() {
    return breakType;
  }

  public void setBreakType(BreakType breakType) {
    this.breakType = breakType;
  }

  public CreateBreakTypeResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public CreateBreakTypeResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * Any errors that occurred during the request.
   * @return errors
  **/
  @ApiModelProperty(value = "Any errors that occurred during the request.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateBreakTypeResponse createBreakTypeResponse = (CreateBreakTypeResponse) o;
    return Objects.equals(this.breakType, createBreakTypeResponse.breakType) &&
        Objects.equals(this.errors, createBreakTypeResponse.errors);
  }

  @Override
  public int hashCode() {
    return Objects.hash(breakType, errors);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateBreakTypeResponse {\n");
    
    sb.append("    breakType: ").append(toIndentedString(breakType)).append("\n");
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

