/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * Filter based on Order &#x60;customer_id&#x60; and any Tender &#x60;customer_id&#x60; associated with the Order. Does not filter based on the [FulfillmentRecipient](#type-orderfulfillmentrecipient) &#x60;customer_id&#x60;.
 */
@ApiModel(description = "Filter based on Order `customer_id` and any Tender `customer_id` associated with the Order. Does not filter based on the [FulfillmentRecipient](#type-orderfulfillmentrecipient) `customer_id`.")

public class SearchOrdersCustomerFilter {
  @JsonProperty("customer_ids")
  private List<String> customerIds = new ArrayList<String>();

  public SearchOrdersCustomerFilter customerIds(List<String> customerIds) {
    this.customerIds = customerIds;
    return this;
  }

  public SearchOrdersCustomerFilter addCustomerIdsItem(String customerIdsItem) {
    this.customerIds.add(customerIdsItem);
    return this;
  }

   /**
   * Filter by orders with any of the listed `customer_id`s.  Max: 10 `customer_id`s.
   * @return customerIds
  **/
  @ApiModelProperty(value = "Filter by orders with any of the listed `customer_id`s.  Max: 10 `customer_id`s.")
  public List<String> getCustomerIds() {
    return customerIds;
  }

  public void setCustomerIds(List<String> customerIds) {
    this.customerIds = customerIds;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchOrdersCustomerFilter searchOrdersCustomerFilter = (SearchOrdersCustomerFilter) o;
    return Objects.equals(this.customerIds, searchOrdersCustomerFilter.customerIds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(customerIds);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchOrdersCustomerFilter {\n");
    
    sb.append("    customerIds: ").append(toIndentedString(customerIds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

